#!/usr/bin/env python3

from fenrirscreenreader.core.i18n import _

import os
import importlib.util

# Load base configuration class
_base_path = os.path.join(os.path.dirname(__file__), '..', 'config_base.py')
_spec = importlib.util.spec_from_file_location("config_base", _base_path)
_module = importlib.util.module_from_spec(_spec)
_spec.loader.exec_module(_module)
ConfigCommand = _module.ConfigCommand


class command(ConfigCommand):
    def __init__(self):
        super().__init__()

    def getDescription(self):
        return "Reload configuration from file"

    def run(self):
        self.presentText("Reloading configuration from file...")

        success = self.reloadConfig()

        if success:
            self.presentText("Configuration reloaded successfully")
            self.playSound('Accept')
        else:
            self.presentText("Failed to reload configuration")
            self.playSound('Error')
