#!/usr/bin/env python3

from fenrirscreenreader.core.i18n import _


class command():
    def __init__(self):
        pass

    def initialize(self, environment):
        self.env = environment

    def shutdown(self):
        pass

    def getDescription(self):
        return "Save current session settings to configuration file"

    def run(self):
        self.env['runtime']['outputManager'].presentText(
            "Saving current session settings to configuration file...", interrupt=True)

        try:
            # This calls the settings manager's save method which writes
            # current runtime settings to file
            self.env['runtime']['settingsManager'].saveSettings()

            self.env['runtime']['outputManager'].presentText(
                "Session settings saved successfully!", interrupt=False, flush=False)
            self.env['runtime']['outputManager'].presentText(
                "All temporary changes are now permanent.", interrupt=False, flush=False)

        except Exception as e:
            self.env['runtime']['outputManager'].presentText(
                f"Failed to save settings: {str(e)}", interrupt=False, flush=False)

    def setCallback(self, callback):
        pass
