#!/usr/bin/env python3

from fenrirscreenreader.core.i18n import _


class command():
    def __init__(self):
        pass

    def initialize(self, environment):
        self.env = environment

    def shutdown(self):
        pass

    def getDescription(self):
        return "Adjust speech pitch (voice height)"

    def run(self):
        try:
            # Get current pitch
            currentPitch = float(
                self.env['runtime']['settingsManager'].getSetting(
                    'speech', 'pitch'))
        except Exception as e:
            currentPitch = 0.5

        # Present current pitch
        pitchPercent = int(currentPitch * 100)
        self.env['runtime']['outputManager'].presentText(
            f"Current speech pitch: {pitchPercent} percent", interrupt=True)

        # Increase by 10%, wrap around if at max
        newPitch = currentPitch + 0.1
        if newPitch > 1.0:
            newPitch = 0.1  # Wrap to minimum

        # Apply the new pitch
        self.env['runtime']['settingsManager'].setSetting(
            'speech', 'pitch', str(newPitch))

        newPercent = int(newPitch * 100)
        self.env['runtime']['outputManager'].presentText(
            f"Speech pitch set to {newPercent} percent", interrupt=True)
        self.env['runtime']['outputManager'].playSound('Accept')

    def setCallback(self, callback):
        pass
