#!/usr/bin/env python3

from fenrirscreenreader.core.i18n import _


class command():
    def __init__(self):
        pass

    def initialize(self, environment):
        self.env = environment

    def shutdown(self):
        pass

    def getDescription(self):
        return "Adjust speech rate (speed)"

    def run(self):
        try:
            # Get current rate
            currentRate = float(
                self.env['runtime']['settingsManager'].getSetting(
                    'speech', 'rate'))
        except Exception as e:
            currentRate = 0.5

        # Present current rate
        ratePercent = int(currentRate * 100)
        self.env['runtime']['outputManager'].presentText(
            f"Current speech rate: {ratePercent} percent", interrupt=True)

        # Increase by 10%, wrap around if at max
        newRate = currentRate + 0.1
        if newRate > 1.0:
            newRate = 0.1  # Wrap to minimum

        # Apply the new rate
        self.env['runtime']['settingsManager'].setSetting(
            'speech', 'rate', str(newRate))

        newPercent = int(newRate * 100)
        self.env['runtime']['outputManager'].presentText(
            f"Speech rate set to {newPercent} percent", interrupt=False, flush=False)

    def setCallback(self, callback):
        pass
