#!/usr/bin/env python3

from fenrirscreenreader.core.i18n import _


class command():
    def __init__(self):
        pass

    def initialize(self, environment):
        self.env = environment

    def shutdown(self):
        pass

    def getDescription(self):
        return "Adjust speech volume (loudness)"

    def run(self):
        try:
            # Get current volume
            currentVolume = float(
                self.env['runtime']['settingsManager'].getSetting(
                    'speech', 'volume'))
        except Exception as e:
            currentVolume = 1.0

        # Present current volume
        volumePercent = int(currentVolume * 100)
        self.env['runtime']['outputManager'].presentText(
            f"Current speech volume: {volumePercent} percent", interrupt=True)

        # Increase by 10%, wrap around if at max
        newVolume = currentVolume + 0.1
        if newVolume > 1.0:
            newVolume = 0.1  # Wrap to minimum

        # Apply the new volume
        self.env['runtime']['settingsManager'].setSetting(
            'speech', 'volume', str(newVolume))

        newPercent = int(newVolume * 100)
        self.env['runtime']['outputManager'].presentText(
            f"Speech volume set to {newPercent} percent", interrupt=True)
        self.env['runtime']['outputManager'].playSound('Accept')

    def setCallback(self, callback):
        pass
