#!/usr/bin/env python3

from fenrirscreenreader.core.i18n import _


class command():
    def __init__(self):
        pass

    def initialize(self, environment):
        self.env = environment

    def shutdown(self):
        pass

    def getDescription(self):
        return "Show current speech settings"

    def run(self):
        # Get current speech settings
        driver = self.env['runtime']['settingsManager'].getSetting(
            'speech', 'driver')
        module = self.env['runtime']['settingsManager'].getSetting(
            'speech', 'module')
        voice = self.env['runtime']['settingsManager'].getSetting(
            'speech', 'voice')
        rate = self.env['runtime']['settingsManager'].getSetting(
            'speech', 'rate')
        pitch = self.env['runtime']['settingsManager'].getSetting(
            'speech', 'pitch')
        volume = self.env['runtime']['settingsManager'].getSetting(
            'speech', 'volume')
        enabled = self.env['runtime']['settingsManager'].getSetting(
            'speech', 'enabled')

        self.env['runtime']['outputManager'].presentText(
            "Current speech settings:", interrupt=True)

        # Present all settings
        self.env['runtime']['outputManager'].presentText(
            f"Speech enabled: {enabled}", interrupt=True)
        self.env['runtime']['outputManager'].presentText(
            f"Driver: {driver}", interrupt=True)

        if module:
            self.env['runtime']['outputManager'].presentText(
                f"Module: {module}", interrupt=True)

        if voice:
            self.env['runtime']['outputManager'].presentText(
                f"Voice: {voice}", interrupt=True)

        try:
            ratePercent = int(float(rate) * 100)
            self.env['runtime']['outputManager'].presentText(
                f"Rate: {ratePercent} percent", interrupt=True)
        except Exception as e:
            self.env['runtime']['outputManager'].presentText(
                f"Rate: {rate}", interrupt=True)

        try:
            pitchPercent = int(float(pitch) * 100)
            self.env['runtime']['outputManager'].presentText(
                f"Pitch: {pitchPercent} percent", interrupt=True)
        except Exception as e:
            self.env['runtime']['outputManager'].presentText(
                f"Pitch: {pitch}", interrupt=True)

        try:
            volumePercent = int(float(volume) * 100)
            self.env['runtime']['outputManager'].presentText(
                f"Volume: {volumePercent} percent", interrupt=True)
        except Exception as e:
            self.env['runtime']['outputManager'].presentText(
                f"Volume: {volume}", interrupt=True)

        self.env['runtime']['outputManager'].playSound('Accept')

    def setCallback(self, callback):
        pass
